'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.commandFactory = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _options = require('./options');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var JQ_PATH = _path2.default.join(__dirname, '..', 'bin', 'jq');

var escapeArg = function escapeArg(arg) {
  arg = arg.toString();

  // Double up all the backslashes and escape the double quote
  arg = arg.replace(/(\\*)"/g, '$1$1\\"');

  // Escape the backslashes that would escape the double quote that's added
  // later to the end of the string
  arg = arg.replace(/(\\*)$/, '$1$1');

  arg = '"' + arg + '"';
  return arg;
};

var shellEscape = function shellEscape(params) {
  return params.reduce(function (previous, current) {
    return previous + ' ' + escapeArg(current);
  }, '');
};

var commandFactory = exports.commandFactory = function commandFactory(filter, json) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  return JQ_PATH + shellEscape((0, _options.parseOptions)(filter, json, options));
};